<!DOCTYPE html><html lang="zh-CN" data-theme="light"><head><meta charset="UTF-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1"><title>Shell语言 —— Linux基础三剑客 | SeMaik</title><meta name="author" content="ZuSir"><meta name="copyright" content="ZuSir"><meta name="format-detection" content="telephone=no"><meta name="theme-color" content="#ffffff"><meta name="description" content="GrepGrep家族 grep egrep fgrep  基础部分常用选项123456789101112131415161718192021-E ：开启扩展（Extend）的正则表达式。-i ：忽略大小写（ignore case）。-v ：反过来（invert），只打印没有匹配的，而匹配的反而不打印。-n ：显示行号-w ：被匹配的文本只能是单词，而不能是单词中的某一部分，如文本中有liker，而">
<meta property="og:type" content="article">
<meta property="og:title" content="Shell语言 —— Linux基础三剑客">
<meta property="og:url" content="http://example.com/2022/02/09/Shell%E8%AF%AD%E8%A8%80-%E2%80%94%E2%80%94-Linux%E5%9F%BA%E7%A1%80%E4%B8%89%E5%89%91%E5%AE%A2/index.html">
<meta property="og:site_name" content="SeMaik">
<meta property="og:description" content="GrepGrep家族 grep egrep fgrep  基础部分常用选项123456789101112131415161718192021-E ：开启扩展（Extend）的正则表达式。-i ：忽略大小写（ignore case）。-v ：反过来（invert），只打印没有匹配的，而匹配的反而不打印。-n ：显示行号-w ：被匹配的文本只能是单词，而不能是单词中的某一部分，如文本中有liker，而">
<meta property="og:locale" content="zh_CN">
<meta property="og:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg">
<meta property="article:published_time" content="2022-02-09T09:15:00.000Z">
<meta property="article:modified_time" content="2022-02-17T03:26:16.155Z">
<meta property="article:author" content="ZuSir">
<meta name="twitter:card" content="summary">
<meta name="twitter:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg"><link rel="shortcut icon" href="https://myit.icu/favicon.ico"><link rel="canonical" href="http://example.com/2022/02/09/Shell%E8%AF%AD%E8%A8%80-%E2%80%94%E2%80%94-Linux%E5%9F%BA%E7%A1%80%E4%B8%89%E5%89%91%E5%AE%A2/"><link rel="preconnect" href="//cdn.jsdelivr.net"/><link rel="preconnect" href="//busuanzi.ibruce.info"/><link rel="stylesheet" href="/css/index.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free/css/all.min.css" media="print" onload="this.media='all'"><script>const GLOBAL_CONFIG = { 
  root: '/',
  algolia: undefined,
  localSearch: undefined,
  translate: undefined,
  noticeOutdate: undefined,
  highlight: {"plugin":"highlighjs","highlightCopy":true,"highlightLang":true},
  copy: {
    success: '复制成功',
    error: '复制错误',
    noSupport: '浏览器不支持'
  },
  relativeDate: {
    homepage: true,
    post: false
  },
  runtime: '',
  date_suffix: {
    just: '刚刚',
    min: '分钟前',
    hour: '小时前',
    day: '天前',
    month: '个月前'
  },
  copyright: undefined,
  lightbox: 'fancybox',
  Snackbar: undefined,
  source: {
    jQuery: 'https://cdn.jsdelivr.net/npm/jquery@latest/dist/jquery.min.js',
    justifiedGallery: {
      js: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/js/jquery.justifiedGallery.min.js',
      css: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/css/justifiedGallery.min.css'
    },
    fancybox: {
      js: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.js',
      css: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.css'
    }
  },
  isPhotoFigcaption: false,
  islazyload: false,
  isanchor: false
}</script><script id="config-diff">var GLOBAL_CONFIG_SITE = { 
  isPost: true,
  isHome: false,
  isHighlightShrink: undefined,
  isToc: true,
  postUpdate: '2022-02-17 11:26:16'
}</script><noscript><style type="text/css">
  #nav {
    opacity: 1
  }
  .justified-gallery img {
    opacity: 1
  }

  #recent-posts time,
  #post-meta time {
    display: inline !important
  }
</style></noscript><script>(win=>{
    win.saveToLocal = {
      set: function setWithExpiry(key, value, ttl) {
        if (ttl === 0) return
        const now = new Date()
        const expiryDay = ttl * 86400000
        const item = {
          value: value,
          expiry: now.getTime() + expiryDay,
        }
        localStorage.setItem(key, JSON.stringify(item))
      },

      get: function getWithExpiry(key) {
        const itemStr = localStorage.getItem(key)

        if (!itemStr) {
          return undefined
        }
        const item = JSON.parse(itemStr)
        const now = new Date()

        if (now.getTime() > item.expiry) {
          localStorage.removeItem(key)
          return undefined
        }
        return item.value
      }
    }
  
    win.getScript = url => new Promise((resolve, reject) => {
      const script = document.createElement('script')
      script.src = url
      script.async = true
      script.onerror = reject
      script.onload = script.onreadystatechange = function() {
        const loadState = this.readyState
        if (loadState && loadState !== 'loaded' && loadState !== 'complete') return
        script.onload = script.onreadystatechange = null
        resolve()
      }
      document.head.appendChild(script)
    })
  
      const asideStatus = saveToLocal.get('aside-status')
      if (asideStatus !== undefined) {
        if (asideStatus === 'hide') {
          document.documentElement.classList.add('hide-aside')
        } else {
          document.documentElement.classList.remove('hide-aside')
        }
      }
    })(window)</script><link href="/css/style.css"><meta name="generator" content="Hexo 5.3.0"><link rel="alternate" href="/atom.xml" title="SeMaik" type="application/atom+xml">
</head><body><div id="web_bg"></div><div id="sidebar"><div id="menu-mask"></div><div id="sidebar-menus"><div class="author-avatar"><img class="avatar-img" src="/img/123.jpeg" onerror="onerror=null;src='/img/123.jpeg'" alt="avatar"/></div><div class="site-data"><div class="data-item is-center"><div class="data-item-link"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div></div><div class="data-item is-center"><div class="data-item-link"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><hr/><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div></div></div><div class="post" id="body-wrap"><header class="post-bg" id="page-header" style="background-image: url('https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg')"><nav id="nav"><span id="blog_name"><a id="site-name" href="/">SeMaik</a></span><div id="menus"><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div><div id="toggle-menu"><a class="site-page"><i class="fas fa-bars fa-fw"></i></a></div></div></nav><div id="post-info"><h1 class="post-title">Shell语言 —— Linux基础三剑客</h1><div id="post-meta"><div class="meta-firstline"><span class="post-meta-date"><i class="far fa-calendar-alt fa-fw post-meta-icon"></i><span class="post-meta-label">发表于</span><time class="post-meta-date-created" datetime="2022-02-09T09:15:00.000Z" title="发表于 2022-02-09 17:15:00">2022-02-09</time><span class="post-meta-separator">|</span><i class="fas fa-history fa-fw post-meta-icon"></i><span class="post-meta-label">更新于</span><time class="post-meta-date-updated" datetime="2022-02-17T03:26:16.155Z" title="更新于 2022-02-17 11:26:16">2022-02-17</time></span><span class="post-meta-categories"><span class="post-meta-separator">|</span><i class="fas fa-inbox fa-fw post-meta-icon"></i><a class="post-meta-categories" href="/categories/Shell/">Shell</a></span></div><div class="meta-secondline"><span class="post-meta-separator">|</span><span class="post-meta-pv-cv"><i class="far fa-eye fa-fw post-meta-icon"></i><span class="post-meta-label">阅读量:</span><span id="busuanzi_value_page_pv"></span></span></div></div></div></header><main class="layout" id="content-inner"><div id="post"><article class="post-content" id="article-container"><h1 id="Grep"><a href="#Grep" class="headerlink" title="Grep"></a>Grep</h1><h2 id="Grep家族"><a href="#Grep家族" class="headerlink" title="Grep家族"></a>Grep家族</h2><ul>
<li>grep</li>
<li>egrep</li>
<li>fgrep</li>
</ul>
<h2 id="基础部分"><a href="#基础部分" class="headerlink" title="基础部分"></a>基础部分</h2><h3 id="常用选项"><a href="#常用选项" class="headerlink" title="常用选项"></a>常用选项</h3><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br></pre></td><td class="code"><pre><span class="line">-E ：开启扩展（Extend）的正则表达式。</span><br><span class="line"></span><br><span class="line">-i ：忽略大小写（ignore case）。</span><br><span class="line"></span><br><span class="line">-v ：反过来（invert），只打印没有匹配的，而匹配的反而不打印。</span><br><span class="line"></span><br><span class="line">-n ：显示行号</span><br><span class="line"></span><br><span class="line">-w ：被匹配的文本只能是单词，而不能是单词中的某一部分，如文本中有liker，而我搜寻的只是like，就可以使用-w选项来避免匹配liker</span><br><span class="line"></span><br><span class="line">-c ：显示总共有多少行被匹配到了，而不是显示被匹配到的内容，注意如果同时使用-cv选项是显示有多少行没有被匹配到。</span><br><span class="line"></span><br><span class="line">-o ：只显示被模式匹配到的字符串。</span><br><span class="line"></span><br><span class="line">--color :将匹配到的内容以颜色高亮显示。</span><br><span class="line"></span><br><span class="line">-A  n：显示匹配到的字符串所在的行及其后n行，after</span><br><span class="line"></span><br><span class="line">-B  n：显示匹配到的字符串所在的行及其前n行，before</span><br><span class="line"></span><br><span class="line">-C  n：显示匹配到的字符串所在的行及其前后各n行，context</span><br></pre></td></tr></table></figure>
<h3 id="操作演示"><a href="#操作演示" class="headerlink" title="操作演示"></a>操作演示</h3><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br></pre></td><td class="code"><pre><span class="line"><span class="comment"># 过滤出包含root的内容</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># grep &quot;root&quot; /etc/passwd</span></span><br><span class="line">root:x:0:0:root:/root:/bin/bash</span><br><span class="line">operator:x:11:0:operator:/root:/sbin/nologin</span><br><span class="line"></span><br><span class="line"><span class="comment"># -i不区分大小过滤root</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># grep -i &quot;root&quot; /etc/ssh/sshd_config </span></span><br><span class="line">PermitRootLogin yes</span><br><span class="line"><span class="comment"># the setting of &quot;PermitRootLogin without-password&quot;.</span></span><br><span class="line"><span class="comment">#ChrootDirectory none</span></span><br><span class="line"></span><br><span class="line"><span class="comment"># 过滤出相关内容并显示行号</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># grep -n &quot;root&quot; /etc/passwd</span></span><br><span class="line">1:root:x:0:0:root:/root:/bin/bash</span><br><span class="line">10:operator:x:11:0:operator:/root:/sbin/nologin</span><br><span class="line"></span><br><span class="line"><span class="comment"># 显示排除匹配到root后还有多少行</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># grep -vc &quot;root&quot; /etc/passwd</span></span><br><span class="line">40</span><br><span class="line"></span><br><span class="line"><span class="comment"># 只显示被匹配到的字符串</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># grep -o &quot;root&quot; /etc/passwd</span></span><br><span class="line">root</span><br><span class="line">root</span><br><span class="line">root</span><br><span class="line">root</span><br><span class="line"></span><br><span class="line"><span class="comment"># 显示匹配到整个单词的字符串</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># grep -w &quot;sh&quot; /etc/passwd</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># grep -w &quot;bash&quot; /etc/passwd</span></span><br><span class="line">root:x:0:0:root:/root:/bin/bash</span><br><span class="line">insocoper:x:1000:1000:insocoper:/home/insocoper:/bin/bash</span><br></pre></td></tr></table></figure>


<h1 id="Sed"><a href="#Sed" class="headerlink" title="Sed"></a>Sed</h1><p><strong>sed在处理文本时是逐行读取文件内容，读到匹配的行就根据指令做操作，不匹配就跳过</strong>。</p>
<p>sed是Linux下一款功能强大的非交互流式文本编辑器，可以对文本文件进行增、删、改、查等操作，支持按行、按字段、按正则匹配文本内容，灵活方便，特别适合于大文件的编辑。本文主要介绍sed的一些基本用法，并通过shell脚本演示sed的使用实例。</p>
<h2 id="常用选项-1"><a href="#常用选项-1" class="headerlink" title="常用选项"></a>常用选项</h2><figure class="highlight plain"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br></pre></td><td class="code"><pre><span class="line">-r：使用扩展正则表达式</span><br><span class="line"></span><br><span class="line">-e：它告诉sed将下一个参数解释为一个sed指令，只有当命令行上给出多个sed指令时才需要使用-e选项</span><br><span class="line"></span><br><span class="line">-f：后跟保存了sed指令的文件</span><br><span class="line"></span><br><span class="line">-i：直接对内容进行修改，不加-i时默认只是预览，不会对文件做实际修改</span><br><span class="line"></span><br><span class="line">-n：取消默认输出，sed默认会输出所有文本内容，使用-n参数后只显示处理过的行</span><br></pre></td></tr></table></figure>
<h2 id="操作演示-1"><a href="#操作演示-1" class="headerlink" title="操作演示"></a>操作演示</h2><h3 id="向文件中添加或插入行"><a href="#向文件中添加或插入行" class="headerlink" title="向文件中添加或插入行"></a>向文件中添加或插入行</h3><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br></pre></td><td class="code"><pre><span class="line"><span class="comment"># 向第三行后面添加hello，3a表示行号</span></span><br><span class="line">sed <span class="string">&#x27;3ahello&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 向内容123后面添加hello，如果文件中有多行包括123，则每一行后面都会添加	</span></span><br><span class="line">sed <span class="string">&#x27;/123/ahello&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 在最后一行添加hello</span></span><br><span class="line">sed <span class="string">&#x27;$ahello&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 在第三行之前插入hello</span></span><br><span class="line">sed <span class="string">&#x27;3ihello&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 在包含123的行之前插入hello，如果有多行包含123，则包含123的每一行之前都会插入hello</span></span><br><span class="line">sed <span class="string">&#x27;/123/ihello&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 在最后一行之前插入hello</span></span><br><span class="line">sed <span class="string">&#x27;$ihello&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 匹配行前加</span></span><br><span class="line">sed -i <span class="string">&#x27;/www.baidu.com/i\www.qq.com&#x27;</span> domain.file</span><br><span class="line"></span><br><span class="line"><span class="comment"># 匹配行后加</span></span><br><span class="line">sed -i <span class="string">&#x27;/www.baidu.com/a\www.qq.com&#x27;</span> domain.file</span><br></pre></td></tr></table></figure>
<h3 id="更改文件中指定的行"><a href="#更改文件中指定的行" class="headerlink" title="更改文件中指定的行"></a>更改文件中指定的行</h3><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br></pre></td><td class="code"><pre><span class="line"><span class="comment"># 将文件1.txt的第一行替换为hello</span></span><br><span class="line">sed <span class="string">&#x27;1chello&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 将包含123的行替换为hello</span></span><br><span class="line">sed <span class="string">&#x27;/123/chello&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 将最后一行替换为hello</span></span><br><span class="line">sed <span class="string">&#x27;$chello&#x27;</span> 1.txt</span><br></pre></td></tr></table></figure>
<h3 id="删除文件中的行"><a href="#删除文件中的行" class="headerlink" title="删除文件中的行"></a>删除文件中的行</h3><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br></pre></td><td class="code"><pre><span class="line"><span class="comment"># 删除第四行</span></span><br><span class="line">sed <span class="string">&#x27;4d&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 从第一行开始删除，每隔2行就删掉一行，即删除奇数行</span></span><br><span class="line">sed <span class="string">&#x27;1~2d&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 删除1~2行</span></span><br><span class="line">sed <span class="string">&#x27;1,2d&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 删除1~2行之外的所有行</span></span><br><span class="line">sed <span class="string">&#x27;1,2!d&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 删除最后一行</span></span><br><span class="line">sed <span class="string">&#x27;$d&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 删除匹配123的行</span></span><br><span class="line">sed <span class="string">&#x27;/123/d&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 删除从匹配123的行到最后一行</span></span><br><span class="line">sed <span class="string">&#x27;/123/,$d&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 删除匹配123的行及其后面一行</span></span><br><span class="line">sed <span class="string">&#x27;/123/,+1d&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 删除空行 </span></span><br><span class="line">sed <span class="string">&#x27;/^$/d&#x27;</span> 1.txt</span><br></pre></td></tr></table></figure>
<h3 id="替换文件中的内容"><a href="#替换文件中的内容" class="headerlink" title="替换文件中的内容"></a>替换文件中的内容</h3><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br></pre></td><td class="code"><pre><span class="line"><span class="comment"># 将文件中的123替换为hello，默认只替换每行第一个123</span></span><br><span class="line">sed -i <span class="string">&#x27;s/123/hello/&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 将文本中所有的123都替换为hello</span></span><br><span class="line">sed -i <span class="string">&#x27;s/123/hello/g&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 将每行中第二个匹配的123替换为hello</span></span><br><span class="line">sed -i <span class="string">&#x27;s/123/hello/2&#x27;</span> 1.txt</span><br></pre></td></tr></table></figure>
<h3 id="打印文件中的行"><a href="#打印文件中的行" class="headerlink" title="打印文件中的行"></a>打印文件中的行</h3><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br></pre></td><td class="code"><pre><span class="line"><span class="comment"># 打印文件中的第三行内容</span></span><br><span class="line">sed -n <span class="string">&#x27;3p&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 打印1到3行</span></span><br><span class="line">sed -n <span class="string">&#x27;1,3p&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 打印文件的最后一行</span></span><br><span class="line">sed -n <span class="string">&#x27;$p&#x27;</span> 1.txt</span><br><span class="line"></span><br><span class="line"><span class="comment"># 打印从第3行到最后一行的内容</span></span><br><span class="line">sed -n <span class="string">&#x27;3,$p&#x27;</span> 1.txt </span><br></pre></td></tr></table></figure>
<h2 id="删除文件中的空白行"><a href="#删除文件中的空白行" class="headerlink" title="删除文件中的空白行"></a>删除文件中的空白行</h2><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">sed -i <span class="string">&quot;/^$/d&quot;</span> <span class="variable">$1</span></span><br></pre></td></tr></table></figure>
<h1 id="Awk"><a href="#Awk" class="headerlink" title="Awk"></a>Awk</h1><p>AWK 是一种处理文本文件的语言，是一个强大的文本分析工具,之所以叫 AWK 是因为其取了三位创始人 Alfred Aho，Peter Weinberger, 和 Brian Kernighan 的 Family Name 的首字符</p>
<p>选项：</p>
<ul>
<li>-F：分割</li>
</ul>
<figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br><span class="line">33</span><br><span class="line">34</span><br><span class="line">35</span><br><span class="line">36</span><br><span class="line">37</span><br><span class="line">38</span><br><span class="line">39</span><br><span class="line">40</span><br><span class="line">41</span><br><span class="line">42</span><br><span class="line">43</span><br><span class="line">44</span><br><span class="line">45</span><br><span class="line">46</span><br><span class="line">47</span><br><span class="line">48</span><br><span class="line">49</span><br><span class="line">50</span><br><span class="line">51</span><br><span class="line">52</span><br></pre></td><td class="code"><pre><span class="line">[root@ansible-server ~]<span class="comment"># cat a.txt </span></span><br><span class="line">/dev/sdb1 /data1 ext4 defaults 0 0</span><br><span class="line">/dev/sdc1 /data2 ext4 defaults 0 0</span><br><span class="line">/dev/sdd1 /data3 ext4 defaults 0 0</span><br><span class="line">/dev/sde1 /data4 ext4 defaults 0 0</span><br><span class="line">/dev/sdf1 /data5 ext4 defaults 0 0</span><br><span class="line">/dev/sdg1 /data6 ext4 defaults 0 0</span><br><span class="line"> </span><br><span class="line"><span class="comment"># 显示第一列</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># cat a.txt | awk &#x27;&#123;print $1&#125;&#x27;</span></span><br><span class="line">/dev/sdb1</span><br><span class="line">/dev/sdc1</span><br><span class="line">/dev/sdd1</span><br><span class="line">/dev/sde1</span><br><span class="line">/dev/sdf1</span><br><span class="line">/dev/sdg1</span><br><span class="line"></span><br><span class="line"><span class="comment"># 显示第一列和第二列</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># cat a.txt | awk &#x27;&#123;print $1,$2&#125;&#x27;</span></span><br><span class="line">/dev/sdb1 /data1</span><br><span class="line">/dev/sdc1 /data2</span><br><span class="line">/dev/sdd1 /data3</span><br><span class="line">/dev/sde1 /data4</span><br><span class="line">/dev/sdf1 /data5</span><br><span class="line">/dev/sdg1 /data6</span><br><span class="line"> </span><br><span class="line"><span class="comment"># 显示最后一列</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># cat a.txt | awk &#x27;&#123;print $(NF)&#125;&#x27;</span></span><br><span class="line">0</span><br><span class="line">0</span><br><span class="line">0</span><br><span class="line">0</span><br><span class="line">0</span><br><span class="line">0</span><br><span class="line"></span><br><span class="line"><span class="comment"># 显示倒数第三列</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># cat a.txt | awk &#x27;&#123;print $(NF -2)&#125;&#x27;</span></span><br><span class="line">defaults</span><br><span class="line">defaults</span><br><span class="line">defaults</span><br><span class="line">defaults</span><br><span class="line">defaults</span><br><span class="line">defaults</span><br><span class="line"></span><br><span class="line"><span class="comment"># 以/号分割，显示第二列</span></span><br><span class="line">[root@ansible-server ~]<span class="comment"># cat a.txt | awk -F &#x27;/&#x27; &#x27;&#123;print $2&#125;&#x27;</span></span><br><span class="line">dev</span><br><span class="line">dev</span><br><span class="line">dev</span><br><span class="line">dev</span><br><span class="line">dev</span><br><span class="line">dev</span><br></pre></td></tr></table></figure>
</article><div class="post-copyright"><div class="post-copyright__author"><span class="post-copyright-meta">文章作者: </span><span class="post-copyright-info"><a href="mailto:undefined">ZuSir</a></span></div><div class="post-copyright__type"><span class="post-copyright-meta">文章链接: </span><span class="post-copyright-info"><a href="http://example.com/2022/02/09/Shell%E8%AF%AD%E8%A8%80-%E2%80%94%E2%80%94-Linux%E5%9F%BA%E7%A1%80%E4%B8%89%E5%89%91%E5%AE%A2/">http://example.com/2022/02/09/Shell%E8%AF%AD%E8%A8%80-%E2%80%94%E2%80%94-Linux%E5%9F%BA%E7%A1%80%E4%B8%89%E5%89%91%E5%AE%A2/</a></span></div><div class="post-copyright__notice"><span class="post-copyright-meta">版权声明: </span><span class="post-copyright-info">本博客所有文章除特别声明外，均采用 <a href="https://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC BY-NC-SA 4.0</a> 许可协议。转载请注明来自 <a href="http://example.com" target="_blank">SeMaik</a>！</span></div></div><div class="tag_share"><div class="post-meta__tag-list"></div><div class="post_share"><div class="social-share" data-image="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" data-sites="facebook,twitter,wechat,weibo,qq"></div><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/social-share.js/dist/css/share.min.css" media="print" onload="this.media='all'"><script src="https://cdn.jsdelivr.net/npm/social-share.js/dist/js/social-share.min.js" defer></script></div></div><nav class="pagination-post" id="pagination"><div class="prev-post pull-left"><a href="/2022/02/17/Ceph%E9%9B%86%E7%BE%A4%E6%89%A9%E5%AE%B9/"><img class="prev-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of previous post"><div class="pagination-info"><div class="label">上一篇</div><div class="prev_info">Ceph集群扩容</div></div></a></div><div class="next-post pull-right"><a href="/2022/02/09/Shell%E8%AF%AD%E8%A8%80-%E2%80%94%E2%80%94-%E4%BC%A0%E9%80%92%E5%8F%82%E6%95%B0/"><img class="next-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of next post"><div class="pagination-info"><div class="label">下一篇</div><div class="next_info">Shell语言 —— 传递参数</div></div></a></div></nav></div><div class="aside-content" id="aside-content"><div class="card-widget card-info"><div class="card-info-avatar is-center"><img class="avatar-img" src="/img/123.jpeg" onerror="this.onerror=null;this.src='/img/123.jpeg'" alt="avatar"/><div class="author-info__name">ZuSir</div><div class="author-info__description">一个收藏回忆与分享技术的地方!</div></div><div class="card-info-data"><div class="card-info-data-item is-center"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div><div class="card-info-data-item is-center"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><div class="card-widget card-announcement"><div class="item-headline"><i class="fas fa-bullhorn card-announcement-animation"></i><span>公告</span></div><div class="announcement_content">This is my Blog! <img src="https://ss0.bdstatic.com/70cFuHSh_Q1YnxGkpoWK1HF6hhy/it/u=3894415926,2787041726&fm=26&gp=0.jpg"></div></div><div class="sticky_layout"><div class="card-widget" id="card-toc"><div class="item-headline"><i class="fas fa-stream"></i><span>目录</span></div><div class="toc-content"><ol class="toc"><li class="toc-item toc-level-1"><a class="toc-link" href="#Grep"><span class="toc-number">1.</span> <span class="toc-text">Grep</span></a><ol class="toc-child"><li class="toc-item toc-level-2"><a class="toc-link" href="#Grep%E5%AE%B6%E6%97%8F"><span class="toc-number">1.1.</span> <span class="toc-text">Grep家族</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E5%9F%BA%E7%A1%80%E9%83%A8%E5%88%86"><span class="toc-number">1.2.</span> <span class="toc-text">基础部分</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%B8%B8%E7%94%A8%E9%80%89%E9%A1%B9"><span class="toc-number">1.2.1.</span> <span class="toc-text">常用选项</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%93%8D%E4%BD%9C%E6%BC%94%E7%A4%BA"><span class="toc-number">1.2.2.</span> <span class="toc-text">操作演示</span></a></li></ol></li></ol></li><li class="toc-item toc-level-1"><a class="toc-link" href="#Sed"><span class="toc-number">2.</span> <span class="toc-text">Sed</span></a><ol class="toc-child"><li class="toc-item toc-level-2"><a class="toc-link" href="#%E5%B8%B8%E7%94%A8%E9%80%89%E9%A1%B9-1"><span class="toc-number">2.1.</span> <span class="toc-text">常用选项</span></a></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E6%93%8D%E4%BD%9C%E6%BC%94%E7%A4%BA-1"><span class="toc-number">2.2.</span> <span class="toc-text">操作演示</span></a><ol class="toc-child"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%90%91%E6%96%87%E4%BB%B6%E4%B8%AD%E6%B7%BB%E5%8A%A0%E6%88%96%E6%8F%92%E5%85%A5%E8%A1%8C"><span class="toc-number">2.2.1.</span> <span class="toc-text">向文件中添加或插入行</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%9B%B4%E6%94%B9%E6%96%87%E4%BB%B6%E4%B8%AD%E6%8C%87%E5%AE%9A%E7%9A%84%E8%A1%8C"><span class="toc-number">2.2.2.</span> <span class="toc-text">更改文件中指定的行</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E5%88%A0%E9%99%A4%E6%96%87%E4%BB%B6%E4%B8%AD%E7%9A%84%E8%A1%8C"><span class="toc-number">2.2.3.</span> <span class="toc-text">删除文件中的行</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%9B%BF%E6%8D%A2%E6%96%87%E4%BB%B6%E4%B8%AD%E7%9A%84%E5%86%85%E5%AE%B9"><span class="toc-number">2.2.4.</span> <span class="toc-text">替换文件中的内容</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%89%93%E5%8D%B0%E6%96%87%E4%BB%B6%E4%B8%AD%E7%9A%84%E8%A1%8C"><span class="toc-number">2.2.5.</span> <span class="toc-text">打印文件中的行</span></a></li></ol></li><li class="toc-item toc-level-2"><a class="toc-link" href="#%E5%88%A0%E9%99%A4%E6%96%87%E4%BB%B6%E4%B8%AD%E7%9A%84%E7%A9%BA%E7%99%BD%E8%A1%8C"><span class="toc-number">2.3.</span> <span class="toc-text">删除文件中的空白行</span></a></li></ol></li><li class="toc-item toc-level-1"><a class="toc-link" href="#Awk"><span class="toc-number">3.</span> <span class="toc-text">Awk</span></a></li></ol></div></div><div class="card-widget card-recent-post"><div class="item-headline"><i class="fas fa-history"></i><span>最新文章</span></div><div class="aside-list"><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Zabbix-Server5-0/" title="Shell程序——部署Zabbix-ServerV5.0">Shell程序——部署Zabbix-ServerV5.0</a><time datetime="2022-02-17T03:32:00.000Z" title="发表于 2022-02-17 11:32:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Harbor/" title="Shell程序——部署Harbor">Shell程序——部署Harbor</a><time datetime="2022-02-17T03:31:00.000Z" title="发表于 2022-02-17 11:31:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94Mysql%E5%A4%87%E4%BB%BD/" title="Shell程序——Mysql备份">Shell程序——Mysql备份</a><time datetime="2022-02-17T03:30:00.000Z" title="发表于 2022-02-17 11:30:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E6%89%B9%E9%87%8F%E4%BF%9D%E5%AD%98Docker-image/" title="Shell程序——批量保存Docker_image">Shell程序——批量保存Docker_image</a><time datetime="2022-02-17T03:29:00.000Z" title="发表于 2022-02-17 11:29:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E5%85%A8%E6%AE%B5IP%E6%89%AB%E6%8F%8F/" title="Shell程序——全段IP扫描">Shell程序——全段IP扫描</a><time datetime="2022-02-17T03:28:00.000Z" title="发表于 2022-02-17 11:28:00">2022-02-17</time></div></div></div></div></div></div></main><footer id="footer"><div id="footer-wrap"><div class="copyright">&copy;2020 - 2022 By ZuSir</div><div class="framework-info"><span>框架 </span><a target="_blank" rel="noopener" href="https://hexo.io">Hexo</a><span class="footer-separator">|</span><span>主题 </span><a target="_blank" rel="noopener" href="https://github.com/jerryc127/hexo-theme-butterfly">Butterfly</a></div></div></footer></div><div id="rightside"><div id="rightside-config-hide"><button id="readmode" type="button" title="阅读模式"><i class="fas fa-book-open"></i></button><button id="hide-aside-btn" type="button" title="单栏和双栏切换"><i class="fas fa-arrows-alt-h"></i></button></div><div id="rightside-config-show"><button id="rightside_config" type="button" title="设置"><i class="fas fa-cog fa-spin"></i></button><button class="close" id="mobile-toc-button" type="button" title="目录"><i class="fas fa-list-ul"></i></button><button id="go-up" type="button" title="回到顶部"><i class="fas fa-arrow-up"></i></button></div></div><div><script src="/js/utils.js"></script><script src="/js/main.js"></script><div class="js-pjax"></div><script defer="defer" id="fluttering_ribbon" mobile="true" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/dist/canvas-fluttering-ribbon.min.js"></script><script async data-pjax src="//busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script></div></body></html>